/* PRO-SCAMS "@@(#) uwdialer.h, Rev: 1.5.0.0" */

/* -----							*/
/* Misc. defines 						*/
/*							  ----- */

#define	FATAL		0x01
#define	NONFATAL	0x02
#define	LARGE		0x03
#define	SMALL		0x04
#define	MANUAL		0x05
#define SYSTEMS		0x06
#define	PERSONAL	0x07
#define	SYSTEM		0x08
#define	INIT		0x09
#define	START		0x0a
#define	RESET		0x0b
#define	RUN		0x0c
#define	MODIFY		0x0d
#define	DELETE		0x0e
#define	TERMINAL	0x0f
#define	XTERM		0x10
#define	ON		0x11
#define	OFF		0x12
#define TINY		0x13
#define	ASCII		0x14
#define	XMODEM		0x15
#define	YMODEM		0x16
#define	ZMODEM		0x17
#define	UPLOAD		0x18
#define	DOWNLOAD	0x19
#define	REWRITE		0x1b

#define	PERSONAL_FILE	".uwdialer_systems"
#define	TARGET_FILE	"/tmp/.uwdialer_temp"
#define	PADDING		20

#define	COMMENT		0x23	/* #       */
#define	NEWLINE		0x0a	/* newline */
#define	RETURN		0x0d    /* carrige return */
#define	TAB		0x09	/* tab     */
#define	SPACE		0x20	/* space   */
#define	READ		"r"
#define	WRITE		"w"
#define	APPEND		"a"
#define	READWRITE	"r+"

#define	MAIN_BUTTONS	8

/* -----							*/
/* Error message defines.					*/
/*							  ----- */

#define	COLORALLOCATION	"Color allocation of color <%s> failed.\n\r"
#define FONTALLOCATION  "Font allocation of font <%s> failed.\n\r"
#define	MISSINGSYSTEM	"No system or line provided, dial fails.\n\r"
#define	DIALFAILS	"Dial failed, errno = %d, msg = %s\n\r"
#define	OUTOFMEMORY	"System out of memory resource.\n\r"
#define	PERSONALFILE	"No personal system file detected <%s>.\n\r"
#define	SYSTEMFILE	"Can't access UUCP Systems file.\n\r"
#define	NOITEMSELECTED	"No system selected in scrolling list.\n\r"
#define	ZEROREAD	"Zero characters read at modem.\n\r"
#define	CANTOPENLOCKDIR	"Can't open UUCP locks directory, restart uwdialer.\n\r"
#define	CANTOPENLOCK	"Can't open lock file <%s>.\n\r"
#define	OPENFORSAVE	"Can't open personal systems file <%s>.\n\r"
#define	TARGETFILE	"Can't open temporary file in /tmp.\n\r"
#define	WRITETARGET	"Trouble writing temporary file.\n\r"
#define	WRITEPERSONAL	"Trouble writing personal systems file <%s>.\n\r"
#define	BADSYSTEMSLIST	"No token found in current system list.\n\r"
#define	LOGGEROPENFAIL	"Failed to open requested log file <%s>.\n\r"
#define	NOLOGGERFILE	"No log file entered.\n\r"
#define	LOGALREADYON	"Session log already active.\n\r"
#define	NOTCONNECTED	"No active session.\n\r"
#define	CANTCREATECHILD	"Fork failed during transfer setup.\n\r"
#define	NOFILESPECIFIED "No source or destination file specified.\n\r"
#define	ALREADYCONNECT  "Already connected to a remote system.\n\r"
#define	PROTOBUFWRFAIL	"Failed to write proto buf to parent.\n\r"
#define	PROTOIOCTL	"Failed to send filedescriptor to parent.\n\r"
#define	STREAMPIPERROR	"Error on stream pipe from child.\n\r"
#define	SERVERTERM	"Server terminated transmitting modem fd.\n\r"
#define	FORMATERROR	"Formatting error in fd transfer protocol.\n\r"
#define	OPENPIPEFAILED	"Failed to open pipe between parent and child.\n\r"
#define	REWRITELOCK	"Failed to rewrite UUCP LCK file <%s>, errno <%d>.\n\r"
#define	ASCIIDOWNLOAD	"Failed to open ASCII download target file, <%s>\n\r"
#define	ASCIIUPLOAD	"Failed to open ASCII upload file, <%s>\n\r"

typedef struct {
	int	Speed;
	int	CharSize;
	int 	Flow;
	int	Parity;
	char	*Line;
	char	*System;
} Dial_Info;

struct sys {
	char System[BUFSIZ];
	char Phone[BUFSIZ];
	char Speed[10];
	char CharSize[10];
	char Parity[10];
	char Flow[10];
	OlListToken token;
	struct sys *next;
};

/* -----						*/
/* Prototypes.						*/
/*						  ----- */

void Call_Quit(Widget, XtPointer, XtPointer),
     Call_Systems(Widget, XtPointer, XtPointer),
     Call_Manual(Widget, XtPointer, XtPointer),
     Call_Hangup(Widget, XtPointer, XtPointer),
     Call_Upload(Widget, XtPointer, XtPointer),
     Call_Downld(Widget, XtPointer, XtPointer),
     Call_SndBrk(Widget, XtPointer, XtPointer),
     Call_Log(Widget, XtPointer, XtPointer),
     Call_Add(Widget, XtPointer, XtPointer);

void DialerError();
void Update_Connect_Clock(XtPointer, XtIntervalId *);
void Update_Display_Logger();
void Update_Display_Xfer();
void Display_Msg(Boolean, char *);
void Call_Repaint_Display(Widget, XEvent *, Region);
void Init_Xterm();
void Install_Font(int, GC);
void Set_Speed(Widget, XtPointer, XtPointer);
void Set_Size(Widget, XtPointer, XtPointer);
void Set_Parity(Widget, XtPointer, XtPointer);
void Set_Flow(Widget, XtPointer, XtPointer);
void Call_Dial(Widget, XtPointer, XtPointer);
void Call_Save(Widget, XtPointer, XtPointer);
void Call_Dismiss(Widget, Widget, XtPointer);
void Call_Systems(Widget, XtPointer, XtPointer);
void Set_Systems(Widget, XtPointer, XtPointer);
void Init_Dial(Dial_Info *, int);
void Chars_At_Modem(XtPointer, int *, XtInputId *);
void Chars_At_Term(XtPointer, int *, XtInputId *);
void Settings(int);
void Call_Edit(Widget, XtPointer, XtPointer);
void Call_Delete(Widget, XtPointer, XtPointer);
void Delete_System(OlListToken);
void Edit_System_List();
void Set_Settings_Screen(char *);
void Modify_Systems(OlListToken, int);
void Insert_Modified_System(FILE *);
void Logger_Popup();
void Xfer_Popup(int);
void Complete_Connection(Dial_Info *, int *, XtInputId *);
void Set_Buttons(int);
void Set_System_Buttons(int);
void Systems_Dismiss(Widget, XtPointer, XtPointer);
void Sys_Dial(Widget, XtPointer, XtPointer);
void MyFree(struct sys *);
void DeleteItems(struct sys *);
void Construct_Dial_Struct(OlListToken);
void Call_Edit(Widget, XtPointer, XtPointer);
void Call_Delete(Widget, XtPointer, XtPointer);
void Delete_Lock(int);
void Init_Personal_file();
void Set_Protocol(Widget, XtPointer, XtPointer);
void Start_Xfer(Widget, XtPointer, XtPointer);
void Drop_Xfer(Widget, XtPointer, XtPointer);
void Receive_Ascii_File(char *);
void Transmit_Ascii_File(char *);
void Show_AsciiProtocol();
void Show_XmodemProtocol();
void Show_YmodemProtocol();
void Show_ZmodemProtocol();

int SetSpeed(struct sys *);
int SetFlow(struct sys *);
int SetCharSize(struct sys *);
int SetParity(struct sys *);
int Report_Speed(struct termios *);

char *Resolve_Dial_Error(int);
char *Strip(char *);

Pixel GetPixelByName(Widget, char *);
XtPointer CONVERT();

